routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'HomeController@index')->name('home.index');

Route::get('login/{driver}', 'Auth\LoginController@redirectToProvider')->name('login.provider');
Route::get('login/{driver}/callback', 'Auth\LoginController@handleProviderCallback')->name('login.provider_callback');
Auth::routes();

// admin page

Route::prefix('/admin')->group(function(){
	
	// admin dashboard
	Route::get('/', function(){
		return redirect()->route('dashboard');
	});

	Route::get('/dashboard', function(){
		return view('backend.pages.dashboard');
	})->name('dashboard')->middleware(['auth', 'role:admin']);


	// media
	Route::prefix('media')->group(function(){
		Route::post('uploads', 'MediaController@uploads')->name('media.uploads');
		Route::get('get_data', 'MediaController@getData')->name('media.get_data');
		Route::get('select_data/{id}', 'MediaController@selectData')->name('media.get_data');
	});

	Route::resource('/media', 'MediaController');

	// product
	Route::get('/product/get_data', 'ProductController@getData')->name('product.get_data');
	Route::resource('/product', 'ProductController');

	// category
	Route::get('/category/get_category', 'CategoryController@getCategory');
	Route::get('/category/get_parent', 'CategoryController@getParent');
	Route::resource('/category', 'CategoryController');

	// tags
	Route::resource('/tag', 'TagController');

	// order
	Route::get('/order/get_data', 'OrderController@getData')->name('order.get_data');
	Route::resource('/order', 'OrderController');

	// coupon
	Route::get('/coupon/get_data', 'CouponController@getData')->name('coupon.get_data');
	Route::resource('/coupon', 'CouponController');

	// comments
	Route::get('/review/get_data', 'CommentController@getData')->name('comment.get_data');
	Route::resource('/review', 'CommentController');

	// menu
	Route::get('/menu/get_data', 'MenuController@getData')->name('menu.get_data');
	Route::post('/menu/bulk_edit', 'MenuController@bulkEdit')->name('menu.bulk_edit');
	Route::get('/menu/get_menu', 'MenuController@getMenu')->name('menu.get_menu');
	Route::resource('/menu', 'MenuController');

	// user
	Route::post('/user/upload', 'UserController@upload');
	Route::resource('/user', 'UserController');

	// role
	Route::resource('/role', 'RoleController');

	// permission
	Route::resource('/permission', 'PermissionController');

	// widget
	Route::resource('/widget', 'WidgetController');


});

// Route::get('/home', 'HomeController@index')->name('home');

// cart
Route::post('/cart/bulk_update', 'CartController@bulkUpdate')->name('cart.bulk_update');
Route::get('/cart/remove/{hash}', 'CartController@remove')->name('cart.remove');
Route::get('/cart/coupon', 'CartController@coupon')->name('cart.coupon');
Route::resource('/cart', 'CartController');

// currency
Route::get('currency/{type}', 'CurrencyController@set');

// shop
Route::resource('/shop', 'ShopController');

// review

Route::resource('/review', 'ReviewController');

// shipping
Route::post('/shipping/get_services', 'ShippingController@getServices')->name('shipping.get_shipping');
Route::resource('/shipping', 'ShippingController');

// checkout
Route::get('/checkout/status', 'CheckoutController@status')->name('checkout.status');
Route::get('/checkout/payment', 'CheckoutController@payment')->name('checkout.payment');
Route::resource('/checkout', 'CheckoutController');

// user memeber
Route::get('/user', function(){
	return redirect()->route('user.dashboard');
});

Route::get('/dashboard', function(){
	return redirect()->route('user.dashboard');
});

Route::prefix('/user')->group(function(){
	Route::get('/dashboard', 'MemberController@dashboard')->name('user.dashboard');
	Route::get('/order', 'MemberController@order')->name('user.order');
	Route::get('/wishlist', 'MemberController@wishlist')->name('user.wishlist');
	Route::get('/reviews', 'MemberController@reviews')->name('user.reviews');
	Route::put('/profile/{id}', 'MemberController@profileUpdate')->name('user.profile_update');
	Route::get('/profile', 'MemberController@profile')->name('user.profile');
	Route::get('/settings', 'MemberController@settings')->name('user.settings');
	Route::post('/settings/change_password', 'MemberController@changePassword')->name('user.change_password');
	Route::get('/settings/otp', 'MemberController@otp')->name('user.otp');
	Route::post('/settings/otp_submit', 'MemberController@otpSubmit')->name('user.otp_submit');
	Route::get('/settings/test', 'MemberController@test')->name('user.test');
});

Route::get('/api_test', 'ApiController@index');
Route::get('/api_test/notification', 'ApiController@notification');
Route::get('/api_test/send_message', 'ApiController@sendMessage');
Route::get('/api_test/helio', 'ApiController@helio');

// product details
Route::get('/{slug}', 'ShopController@details')->name('shop.details');

app/Role.php
<?php

namespace App;

use Zizaco\Entrust\EntrustRole;

class Role extends EntrustRole
{
 	protected $table = 'tb_m_roles';
 	protected $fillable = ['*'];
 	
}

app/Http/Controllers/RoleController.php
<?php

/*

@author : Fuadz
@created_at : 1512014970

*/

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DataTables;
use DB;
use App\Role;
use App\Permission;

class RoleController extends Controller
{

    public function __construct()
    {
        $this->middleware(['auth', 'role:admin']);
    }
    
    public function index(Request $request)
    {

    	if ($request->ajax()) {

    		$role = Role::get();

    		return DataTables::of($role)

    		->rawColumns(['options'])
			->addColumn('options', function($data){

	    		return '<a href="'.route('role.edit', $data->id).'" class="btn btn-primary btn-xs">
	    					Edit
						</a>
	    				<button class="btn btn-danger btn-xs" onclick="on_delete('.$data->id.')">Delete</button>
	    				<a class="btn btn-info btn-xs" href="'.route('role.show', $data->id).'">
	    					View
						</a>';
	    	})

    		->make(true);


    	} else {

    		return view('backend.pages.role.index');
    	}
    	
    }

    public function create()
    {
    	$permissions = Permission::where('parent_id', 0)
    							->get();

    	$data = [
	    			'permissions' => $permissions
	    		];

    	return view('backend.pages.role.create')
    			->with($data);
    }

    public function store(Request $request)
    {

    	DB::transaction(function() use ($request) {

    		$role = new Role;
    		$role->name = $request->name;
	    	$role->display_name = $request->display_name;
	    	$role->description = $request->description;
	    	$role->save();

	    	$role->perms()->sync($request->permission_id);

    	});

    	$res = [
    				'title' => 'Success',
    				'type' => 'success',
    				'message' => 'Data has been saved successfuly!'
				];

    	return redirect()
    				->route('role.index')
    				->with($res);
    }

    public function edit($id)
    {
    	$permissions = Permission::where('parent_id', 0)
    							->get();
    	$role = Role::find($id);

    	$data = [
	    			'permissions' => $permissions,
	    			'role' => $role
    			];

    	return view('backend.pages.role.edit')
    			->with($data);


    }

    public function update(Request $request, $id)
    {

    	DB::transaction(function() use ($request, $id) {

    		$role = Role::find($id);
    		$role->name = $request->name;
	    	$role->display_name = $request->display_name;
	    	$role->description = $request->description;
	    	$role->save();

	    	$role->perms()->sync($request->permission_id);

    	});

    	$res = [
    				'title' => 'Success',
    				'type' => 'success',
    				'message' => 'Data has been updated successfuly!'
				];

    	return redirect()
    				->route('role.index')
    				->with($res);
    }

    public function show($id)
    {

    	$role = Role::find($id);

    	$data = [
	    			'role' => $role
    			];


    	return view('backend.pages.role.show')
    			->with($data);
    }

    public function destroy(Request $request, $id)
    {

    	if ($request->ajax()) {

    		DB::transaction(function() use ($id){

	    		$role = Role::find($id);
	    		$role->perms()->sync([]);
	    		$role->delete();

	    	});

	    	$res = [
	    				'title' => 'Success',
	    				'type' => 'success',
	    				'message' => 'Data has been deleted successfuly!'
					];

	    	return response()->json($res);
    	}	
    	
    }
}

resources/views/backend/pages/role/create.blade.php
@extends('backend.layouts.master')
@section('title')
Create new role
@endsection
@section('content')

<div class="section-heading">
	<h1 class="page-title">Create new role</h1>
	<div class="pull-right">
		<a href="{{ route('role.index') }}" class="btn btn-primary">Back</a>
	</div>
</div>

<form action="{{ route('role.store') }}" method="post" id="form-add-edit">
	{{ csrf_field() }}
	<div class="row">
		<div class="col-md-12">
			<div class="panel-content">
				<div class="col-md-6">
					<div class="form-group">
						<label class="control-label">Role Name<span class="text-danger">*</span></label>
						<input type="text" name="name" class="form-control" placeholder="eg: admin" required="required">
						<span class="help-block"></span>
					</div>


					<div class="form-group">
						<label class="control-label">Display Name<span class="text-danger">*</span></label>
						<input type="text" name="display_name" class="form-control" placeholder="eg: Admin" required="required">
						<span class="help-block"></span>
					</div>

				</div>

				<div class="col-md-6">
					<div class="form-group">
						<label class="control-label">Description</label>
						<textarea name="description" placeholder="Description" class="form-control" rows="5"></textarea>
					</div>

				</div>

				<div class="col-md-12" style="margin-top: 20px">
					<h3 class="panel-title">Permission</h3>
					<hr>
				</div>

				@foreach ($permissions as $permission)
				<div class="col-md-3">
					<ul class="no-list">
					    <li>
					      	<label class="fancy-checkbox custom-bgcolor-green">
								<input type="checkbox" name="permission_id[]" value="{{ $permission->id }}" class="parent parent-{{ $permission->id }}" data-value="{{ $permission->id }}"><span>{{ $permission->display_name }}</span>
							</label>
							<ul class="no-list">
								@foreach ($permission->children as $children)
								<li>
									<label class="fancy-checkbox custom-bgcolor-green">
										<input type="checkbox" name="permission_id[]" value="{{ $children->id }}" class=" children children-{{ $permission->id}}" data-value="{{ $permission->id }}"><span>{{ $children->display_name }}</span>
									</label>
								</li>
								@endforeach
							</ul>
					    </li>
				  	</ul>
				</div>
				@endforeach

				

				<div class="col-md-12">
					<hr>
					<div class="pull-right">
						<button class="btn btn-default" type="reset">Reset</button>
						<button class="btn btn-primary" type="submit">Save</button>
					</div>
				</div>

			</div>
		</div>
	</div>
</form>

@endsection

@push('js')
<script src="{{ url('assets/backend/pages/js/role-create-edit.js') }}"></script>
@endpush

resources/views/backend/pages/role/edit.blade.php
@extends('backend.layouts.master')
@section('title')
Edit role
@endsection
@section('content')

<div class="section-heading">
	<h1 class="page-title">Edit role</h1>
	<div class="pull-right">
		<a href="{{ route('role.index') }}" class="btn btn-primary">Back</a>
	</div>
</div>

<form action="{{ route('role.update', $role->id) }}" method="post" id="form-add-edit">
	{{ csrf_field() }}
	{{ method_field('PUT') }}
	<div class="row">
		<div class="col-md-12">
			<div class="panel-content">
				<div class="col-md-6">
					<div class="form-group">
						<label class="control-label">Role Name<span class="text-danger">*</span></label>
						<input type="text" name="name" value="{{ $role->name }}" class="form-control" placeholder="eg: admin" required="required">
						<span class="help-block"></span>
					</div>


					<div class="form-group">
						<label class="control-label">Display Name<span class="text-danger">*</span></label>
						<input type="text" name="display_name" value="{{ $role->display_name }}" class="form-control" placeholder="eg: Admin" required="required">
						<span class="help-block"></span>
					</div>

				</div>

				<div class="col-md-6">
					<div class="form-group">
						<label class="control-label">Description</label>
						<textarea name="description" placeholder="Description" class="form-control" rows="5">{{ $role->description }}</textarea>
					</div>

				</div>

				<div class="col-md-12" style="margin-top: 20px">
					<h3 class="panel-title">Permission</h3>
					<hr>
				</div>

				@foreach ($permissions as $permission)
				<div class="col-md-3">
					<ul class="no-list">
					    <li>
					      	<label class="fancy-checkbox custom-bgcolor-green">
								<input type="checkbox" name="permission_id[]" value="{{ $permission->id }}" class="parent parent-{{ $permission->id }}" data-value="{{ $permission->id }}" {{in_array($permission->id, $role->perms()->pluck('id')->toArray()) ? 'checked=checked' : '' }}><span>{{ $permission->display_name }}</span>
							</label>
							<ul class="no-list">
								@foreach ($permission->children as $children)
								<li>
									<label class="fancy-checkbox custom-bgcolor-green">
										<input type="checkbox" name="permission_id[]" value="{{ $children->id }}" class=" children children-{{ $permission->id}}" data-value="{{ $permission->id }}"  {{in_array($children->id, $role->perms()->pluck('id')->toArray()) ? 'checked=checked' : '' }}><span>{{ $children->display_name }}</span>
									</label>
								</li>
								@endforeach
							</ul>
					    </li>
				  	</ul>
				</div>
				@endforeach

				

				<div class="col-md-12">
					<hr>
					<div class="pull-right">
						<button class="btn btn-default" type="reset">Reset</button>
						<button class="btn btn-primary" type="submit">Save Changes</button>
					</div>
				</div>

			</div>
		</div>
	</div>
</form>

@endsection

@push('js')
<script src="{{ url('assets/backend/pages/js/role-create-edit.js') }}"></script>
@endpush

resources/views/backend/pages/role/index.blade.php
@extends('backend.layouts.master')
@section('title')
Role
@endsection
@section('content')

<div class="section-heading">
	<h1 class="page-title">Role</h1>
	<div class="pull-right">
		<a href="{{ route('role.create') }}" class="btn btn-primary">Add new</a>
	</div>
</div>

<div class="row">
	<div class="col-md-12">
		<div class="panel-content">
			<table class="table table-bordered" id="tbl-role">
				<thead>
					<tr>
						<th>Role Name</th>
						<th>Display Name</th>
						<th>Description</th>
						<th>Option</th>
					</tr>
				</thead>
			</table>
		</div>
	</div>
</div>


<!-- Modal for question -->
<div class="modal fade in" tabindex="-1" role="dialog" id="modal-delete-confirm">
    <div class="modal-dialog modal-sm">
        <div class="modal-content">
            <div class="modal-header">
                <button aria-hidden="true" data-dismiss="modal" class="close" type="button">×</button>
                <h4 class="modal-title">Are you sure</h4>
            </div>
            <div class="modal-body">Selected data will be destroyed, are you sure?</div>
            <div class="modal-footer">
                <button type="button" id="btn-confirm" class="btn btn-primary btn-sm">Yes</button>
                <button type="button" class="btn btn-default btn-sm" data-dismiss="modal">No (Cancel)</button>
            </div>
        </div>
    </div>
</div>

@endsection

@push('js')

@if (session()->has('message'))
<script type="text/javascript">
	show_notification("{{ session('title') }}","{{ session('type') }}","{{ session('message') }}");
</script>
@endif

<script src="{{ url('assets/backend/pages/js/role.js') }}"></script>
@endpush

resources/views/backend/pages/role/show.blade.php
@extends('backend.layouts.master')
@section('title')
{{ $role->display_name }}
@endsection
@section('content')

<div class="section-heading">
	<h1 class="page-title">{{ $role->display_name }}</h1>
	<div class="pull-right">
		<a href="{{ route('role.index') }}" class="btn btn-primary">Back</a>
	</div>
</div>
<div class="row">
	<div class="col-md-12">
		<div class="panel-content">
			<table class="table table-primary table-custom">
				<tr class="info">
					<td colspan="2">Role Information</td>
					<td style="width: 350px">Permission</td>
				</tr>
				<tr>
					<td>Role Name</td>
					<td>{{ $role->name }}</td>
					<td rowspan="3">
						{!! '<span class="badge bg-info" style="margin: 5px">'.$role->perms()->pluck('display_name')->implode('</span><span class="badge bg-info" style="margin: 5px">') !!}
					</td>
				</tr>
				<tr>
					<td>Display Name</td>
					<td>{{ $role->display_name }}</td>
				</tr>
				<tr>
					<td>Description</td>
					<td>{{ $role->description }}</td>
				</tr>
			</table>
		</div>
	</div>
</div>
@endsection